'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = withBaseField;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _CheckField = require('./CheckField');

var _CheckField2 = _interopRequireDefault(_CheckField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function withBaseField(WrappedComponent) {
  return function (_React$Component) {
    _inherits(_class, _React$Component);

    function _class() {
      _classCallCheck(this, _class);

      return _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
    }

    _createClass(_class, [{
      key: 'render',
      value: function render() {
        var error = void 0;

        if (this.props.error) {
          error = _react2.default.createElement(
            'div',
            { className: 'invalid-feedback', style: { marginBottom: 10 } },
            Array.isArray(this.props.error) ? this.props.error.map(function (error, index) {
              return _react2.default.createElement(
                'span',
                { key: index, style: { display: 'block' } },
                error
              );
            }) : _react2.default.createElement(
              'span',
              null,
              error
            )
          );
        }

        var help = void 0;

        if (this.props.children) {
          help = _react2.default.createElement(
            'small',
            { className: 'form-text' },
            this.props.children
          );
        }

        if (this instanceof _CheckField2.default) {
          var _label = void 0;

          if (this.props.label) {
            _label = _react2.default.createElement(
              'label',
              { className: 'form-check-label', htmlFor: 'check-' + this.props.name },
              this.props.label
            );
          }

          return _react2.default.createElement(
            'div',
            { className: 'form-check' },
            _react2.default.createElement(WrappedComponent, this.props),
            _label,
            error,
            help
          );
        }

        var label = void 0;

        if (this.props.label) {
          label = _react2.default.createElement(
            'label',
            null,
            this.props.label
          );
        }

        return _react2.default.createElement(
          _react2.default.Fragment,
          null,
          label,
          _react2.default.createElement(WrappedComponent, this.props),
          error,
          help
        );
      }
    }], [{
      key: 'defaultProps',
      get: function get() {
        return {
          name: null,
          enabled: true,
          onChange: function onChange(name, value) {
            console.info('Implement onChange for \'' + name + '\'');
          }
        };
      }
    }]);

    return _class;
  }(_react2.default.Component);
}